/// <reference types="backend-plus" />
import { AppOperativosType, OptsClientPage } from "operativos";
import { Constructor, Request, AppBackend, TablaDatos } from "./types-datos-ext";
export * from "./types-datos-ext";
export declare function emergeAppDatosExt<T extends Constructor<AppOperativosType>>(Base: T): {
    new (...args: any[]): {
        configStaticConfig(): void;
        generateBaseTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinition;
        getProcedures(): Promise<import("backend-plus").ProcedureDef[]>;
        clientIncludes(req: Request, hideBEPlusInclusions: OptsClientPage): import("backend-plus").ClientModuleDefinition[];
        prepareGetTables(): void;
        tablasDatos: TablaDatos[];
        cargarGenerados(client: import("pg-promise-strict").Client): Promise<string>;
        /* mixin-patch: postConfig: (() => Promise<void>) & ((...params: any[]) => Promise<void>); */
        getTableDefFunction(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        loadTableDef(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        generateAndLoadTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinitionFunction;
        /* mixin-patch: getMenu: (() => import("operativos").MenuDefinition) & ((context?: import("backend-plus").Context | undefined) => import("backend-plus").MenuDefinition); */
        /* mixin-patch: checkDatabaseStructure: ((client: import("pg-promise-strict").Client) => Promise<void>) & ((client: import("pg-promise-strict").Client) => Promise<void>); */
        /* mixin-patch: getDbFunctions: ((opts: import("backend-plus").DumpOptions) => Promise<{
            dumpText: string;
        }[]>) & ((opts: import("backend-plus").DumpOptions) => Promise<{
            dumpText: string;
        }[]>); */
        procedures: import("backend-plus").ProcedureDef[];
        procedure: {
            [key: string]: import("backend-plus").ProcedureDef;
        } & {
            [key: string]: import("backend-plus").ProcedureDef;
        };
        app: import("backend-plus").ExpressPlus;
        getTableDefinition: import("backend-plus").TableDefinitionsGetters;
        tableStructures: import("backend-plus").TableDefinitions;
        db: typeof import("pg-promise-strict");
        config: any;
        rootPath: string;
        caches: {
            procedures: {
                [k: string]: {
                    timestamp: number;
                    result: any;
                };
            };
        } & {
            procedures: {
                [k: string]: {
                    timestamp: number;
                    result: any;
                };
            };
        };
        fieldDomain: {
            [k: string]: Partial<import("backend-plus").FieldDefinition>;
        } & {
            [k: string]: Partial<import("backend-plus").FieldDefinition>;
        };
        exts: {
            img: string[];
            normal: string[];
        } & {
            img: string[];
            normal: string[];
        };
        optsGenericForAll: {
            allowedExts?: string[] | undefined;
        } & {
            allowedExts?: string[] | undefined;
        };
        sqls: {
            [k: string]: string;
        } & {
            [k: string]: string;
        };
        messages: {
            [k: string]: string;
        } & {
            [k: string]: string;
        };
        dbUserNameExpr: string;
        dbUserRolExpr: string;
        specialValueWhenInsert: {
            [k: string]: (context: import("backend-plus").ProcedureContext, defField: import("backend-plus").FieldDefinition, parameters: object) => any;
        } & {
            [k: string]: (context: import("backend-plus").ProcedureContext, defField: import("backend-plus").FieldDefinition, parameters: object) => any;
        };
        /* mixin-patch: clearCaches: (() => void) & (() => void); */
        /* mixin-patch: start: ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>) & ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>); */
        /* mixin-patch: getTables: (() => import("backend-plus").TableItemDef[]) & (() => import("backend-plus").TableItemDef[]); */
        /* mixin-patch: appendToTableDefinition: ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void) & ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void); */
        /* mixin-patch: getContext: ((req: Request) => import("backend-plus").Context) & ((req: Request) => import("backend-plus").Context); */
        /* mixin-patch: addSchrödingerServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void); */
        /* mixin-patch: addUnloggedServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void); */
        /* mixin-patch: addLoggedServices: (() => void) & (() => void); */
        /* mixin-patch: inDbClient: (<T_1>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>) & (<T_2>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T_2>) => Promise<T_2>); */
        /* mixin-patch: inTransaction: (<T_1>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>) & (<T_3>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_3>) => Promise<T_3>); */
        /* mixin-patch: procedureDefCompleter: ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef) & ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef); */
        /* mixin-patch: tableDefAdapt: ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition) & ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition); */
        /* mixin-patch: pushApp: ((dirname: string) => void) & ((dirname: string) => void); */
        /* mixin-patch: dumpDbSchemaPartial: ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: import("backend-plus").DumpOptions | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>) & ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: import("backend-plus").DumpOptions | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>); */
        /* mixin-patch: getContextForDump: (() => import("backend-plus").ContextForDump) & (() => import("backend-plus").ContextForDump); */
        /* mixin-patch: getClientSetupForSendToFrontEnd: ((req: Request) => import("backend-plus").ClientSetup) & ((req: Request) => import("backend-plus").ClientSetup); */
        /* mixin-patch: configList: (() => (string | object)[]) & (() => (string | object)[]); */
        /* mixin-patch: setStaticConfig: ((defConfigYamlString: string) => void) & ((defConfigYamlString: string) => void); */
        /* mixin-patch: mainPage: ((req: {} | Request, offlineMode?: boolean | undefined, opts?: OptsClientPage | undefined) => {
            toHtmlDoc: () => string;
        }) & ((req: {} | Request, offlineMode?: boolean | undefined, opts?: OptsClientPage | undefined) => {
            toHtmlDoc: () => string;
        }); */
        /* mixin-patch: isThisProcedureAllowed: (<T_2>(context: import("backend-plus").Context, procedureDef: import("backend-plus").ProcedureDef, params: {
            [key: string]: T_2;
        }) => Promise<boolean>) & (<T_4>(context: import("backend-plus").Context, procedureDef: import("backend-plus").ProcedureDef, params: {
            [key: string]: T_4;
        }) => Promise<boolean>); */
        dumpDbTableFields(tableDefinition: import("backend-plus").TableDefinition): string[];
        i18n: {
            messages: Record<import("backend-plus").LangId, Record<string, string>>;
        };
    };
} & T;
export declare var AppDatosExt: {
    new (...args: any[]): {
        configStaticConfig(): void;
        generateBaseTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinition;
        getProcedures(): Promise<import("backend-plus").ProcedureDef[]>;
        clientIncludes(req: Request, hideBEPlusInclusions: OptsClientPage): import("backend-plus").ClientModuleDefinition[];
        prepareGetTables(): void;
        tablasDatos: TablaDatos[];
        cargarGenerados(client: import("pg-promise-strict").Client): Promise<string>;
        /* mixin-patch: postConfig: (() => Promise<void>) & ((...params: any[]) => Promise<void>); */
        getTableDefFunction(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        loadTableDef(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        generateAndLoadTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinitionFunction;
        /* mixin-patch: getMenu: (() => import("operativos").MenuDefinition) & ((context?: import("backend-plus").Context | undefined) => import("backend-plus").MenuDefinition); */
        /* mixin-patch: checkDatabaseStructure: ((client: import("pg-promise-strict").Client) => Promise<void>) & ((client: import("pg-promise-strict").Client) => Promise<void>); */
        /* mixin-patch: getDbFunctions: ((opts: import("backend-plus").DumpOptions) => Promise<{
            dumpText: string;
        }[]>) & ((opts: import("backend-plus").DumpOptions) => Promise<{
            dumpText: string;
        }[]>); */
        procedures: import("backend-plus").ProcedureDef[];
        procedure: {
            [key: string]: import("backend-plus").ProcedureDef;
        } & {
            [key: string]: import("backend-plus").ProcedureDef;
        };
        app: import("backend-plus").ExpressPlus;
        getTableDefinition: import("backend-plus").TableDefinitionsGetters;
        tableStructures: import("backend-plus").TableDefinitions;
        db: typeof import("pg-promise-strict");
        config: any;
        rootPath: string;
        caches: {
            procedures: {
                [k: string]: {
                    timestamp: number;
                    result: any;
                };
            };
        } & {
            procedures: {
                [k: string]: {
                    timestamp: number;
                    result: any;
                };
            };
        };
        fieldDomain: {
            [k: string]: Partial<import("backend-plus").FieldDefinition>;
        } & {
            [k: string]: Partial<import("backend-plus").FieldDefinition>;
        };
        exts: {
            img: string[];
            normal: string[];
        } & {
            img: string[];
            normal: string[];
        };
        optsGenericForAll: {
            allowedExts?: string[] | undefined;
        } & {
            allowedExts?: string[] | undefined;
        };
        sqls: {
            [k: string]: string;
        } & {
            [k: string]: string;
        };
        messages: {
            [k: string]: string;
        } & {
            [k: string]: string;
        };
        dbUserNameExpr: string;
        dbUserRolExpr: string;
        specialValueWhenInsert: {
            [k: string]: (context: import("backend-plus").ProcedureContext, defField: import("backend-plus").FieldDefinition, parameters: object) => any;
        } & {
            [k: string]: (context: import("backend-plus").ProcedureContext, defField: import("backend-plus").FieldDefinition, parameters: object) => any;
        };
        /* mixin-patch: clearCaches: (() => void) & (() => void); */
        /* mixin-patch: start: ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>) & ((opts?: import("backend-plus").StartOptions | undefined) => Promise<void>); */
        /* mixin-patch: getTables: (() => import("backend-plus").TableItemDef[]) & (() => import("backend-plus").TableItemDef[]); */
        /* mixin-patch: appendToTableDefinition: ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void) & ((tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void) => void); */
        /* mixin-patch: getContext: ((req: Request) => import("backend-plus").Context) & ((req: Request) => import("backend-plus").Context); */
        /* mixin-patch: addSchrödingerServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void); */
        /* mixin-patch: addUnloggedServices: ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void) & ((mainApp: import("backend-plus").ExpressPlus, baseUrl: string) => void); */
        /* mixin-patch: addLoggedServices: (() => void) & (() => void); */
        /* mixin-patch: inDbClient: (<T>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T>) => Promise<T>) & (<T_1>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>); */
        /* mixin-patch: inTransaction: (<T_1>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_1>) => Promise<T_1>) & (<T_2>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_2>) => Promise<T_2>); */
        /* mixin-patch: procedureDefCompleter: ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef) & ((procedureDef: import("backend-plus").ProcedureDef) => import("backend-plus").ProcedureDef); */
        /* mixin-patch: tableDefAdapt: ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition) & ((tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context) => import("backend-plus").TableDefinition); */
        /* mixin-patch: pushApp: ((dirname: string) => void) & ((dirname: string) => void); */
        /* mixin-patch: dumpDbSchemaPartial: ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: import("backend-plus").DumpOptions | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>) & ((partialTableStructures: import("backend-plus").TableDefinitions, opts?: import("backend-plus").DumpOptions | undefined) => Promise<{
            mainSql: string;
            enancePart: string;
        }>); */
        /* mixin-patch: getContextForDump: (() => import("backend-plus").ContextForDump) & (() => import("backend-plus").ContextForDump); */
        /* mixin-patch: getClientSetupForSendToFrontEnd: ((req: Request) => import("backend-plus").ClientSetup) & ((req: Request) => import("backend-plus").ClientSetup); */
        /* mixin-patch: configList: (() => (string | object)[]) & (() => (string | object)[]); */
        /* mixin-patch: setStaticConfig: ((defConfigYamlString: string) => void) & ((defConfigYamlString: string) => void); */
        /* mixin-patch: mainPage: ((req: {} | Request, offlineMode?: boolean | undefined, opts?: OptsClientPage | undefined) => {
            toHtmlDoc: () => string;
        }) & ((req: {} | Request, offlineMode?: boolean | undefined, opts?: OptsClientPage | undefined) => {
            toHtmlDoc: () => string;
        }); */
        /* mixin-patch: isThisProcedureAllowed: (<T_2>(context: import("backend-plus").Context, procedureDef: import("backend-plus").ProcedureDef, params: {
            [key: string]: T_2;
        }) => Promise<boolean>) & (<T_3>(context: import("backend-plus").Context, procedureDef: import("backend-plus").ProcedureDef, params: {
            [key: string]: T_3;
        }) => Promise<boolean>); */
        dumpDbTableFields(tableDefinition: import("backend-plus").TableDefinition): string[];
        i18n: {
            messages: Record<import("backend-plus").LangId, Record<string, string>>;
        };
    };
} & {
    new (...args: any[]): {
        tablasDatos: TablaDatos[];
        configStaticConfig(): void;
        cargarGenerados(client: import("pg-promise-strict").Client): Promise<string>;
        postConfig(): Promise<void>;
        generateBaseTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinition;
        getTableDefFunction(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        loadTableDef(tableDef: import("backend-plus").TableDefinition): import("backend-plus").TableDefinitionFunction;
        generateAndLoadTableDef(tablaDatos: TablaDatos): import("backend-plus").TableDefinitionFunction;
        clientIncludes(req: Request, hideBEPlusInclusions: OptsClientPage): import("backend-plus").ClientModuleDefinition[];
        getMenu(): import("operativos").MenuDefinition;
        prepareGetTables(): void;
        checkDatabaseStructure(client: import("pg-promise-strict").Client): Promise<void>;
        getDbFunctions(opts: import("backend-plus").DumpOptions): Promise<{
            dumpText: string;
        }[]>;
        procedures: import("backend-plus").ProcedureDef[];
        procedure: {
            [key: string]: import("backend-plus").ProcedureDef;
        };
        app: import("backend-plus").ExpressPlus;
        getTableDefinition: import("backend-plus").TableDefinitionsGetters;
        tableStructures: import("backend-plus").TableDefinitions;
        db: typeof import("pg-promise-strict");
        config: any;
        rootPath: string;
        caches: {
            procedures: {
                [k: string]: {
                    timestamp: number;
                    result: any;
                };
            };
        };
        fieldDomain: {
            [k: string]: Partial<import("backend-plus").FieldDefinition>;
        };
        exts: {
            img: string[];
            normal: string[];
        };
        optsGenericForAll: {
            allowedExts?: string[] | undefined;
        };
        sqls: {
            [k: string]: string;
        };
        messages: {
            [k: string]: string;
        };
        dbUserNameExpr: string;
        dbUserRolExpr: string;
        specialValueWhenInsert: {
            [k: string]: (context: import("backend-plus").ProcedureContext, defField: import("backend-plus").FieldDefinition, parameters: object) => any;
        };
        clearCaches(): void;
        start(opts?: import("backend-plus").StartOptions | undefined): Promise<void>;
        getTables(): import("backend-plus").TableItemDef[];
        appendToTableDefinition(tableName: string, appenderFunction: (tableDef: import("backend-plus").TableDefinition, context?: import("backend-plus").TableContext | undefined) => void): void;
        getContext(req: Request): import("backend-plus").Context;
        addSchrödingerServices(mainApp: import("backend-plus").ExpressPlus, baseUrl: string): void;
        addUnloggedServices(mainApp: import("backend-plus").ExpressPlus, baseUrl: string): void;
        addLoggedServices(): void;
        getProcedures(): Promise<import("backend-plus").ProcedureDef[]>;
        inDbClient<T_1_1>(req: Request | null, doThisWithDbClient: (client: import("pg-promise-strict").Client) => Promise<T_1_1>): Promise<T_1_1>;
        inTransaction<T_2_1>(req: Request | null, doThisWithDbTransaction: (client: import("pg-promise-strict").Client) => Promise<T_2_1>): Promise<T_2_1>;
        procedureDefCompleter(procedureDef: import("backend-plus").ProcedureDef): import("backend-plus").ProcedureDef;
        tableDefAdapt(tableDef: import("backend-plus").TableDefinition, context: import("backend-plus").Context): import("backend-plus").TableDefinition;
        pushApp(dirname: string): void;
        dumpDbSchemaPartial(partialTableStructures: import("backend-plus").TableDefinitions, opts?: import("backend-plus").DumpOptions | undefined): Promise<{
            mainSql: string;
            enancePart: string;
        }>;
        getContextForDump(): import("backend-plus").ContextForDump;
        getClientSetupForSendToFrontEnd(req: Request): import("backend-plus").ClientSetup;
        configList(): (string | object)[];
        setStaticConfig(defConfigYamlString: string): void;
        mainPage(req: {} | Request, offlineMode?: boolean | undefined, opts?: OptsClientPage | undefined): {
            toHtmlDoc: () => string;
        };
        isThisProcedureAllowed<T_3>(context: import("backend-plus").Context, procedureDef: import("backend-plus").ProcedureDef, params: {
            [key: string]: T_3;
        }): Promise<boolean>;
    };
    prefixTableName(tableName: string, prefix: string): string;
} & typeof AppBackend;
